/*
Problem: cross
Contest: UOI 2012
Solution: Straightforward O(N^2 * K)
Author: Andrii Korotkov
*/

#include <cstdio>
#include <algorithm>

using namespace std;

#define K 100005

#define X first
#define Y second

int n,k;
pair<int,int> p[K];
int xo,yo,optd;

int main()
{
	freopen("cross.dat","r",stdin);
	freopen("cross.sol","w",stdout);
	scanf("%d%d",&n,&k);
	for(int i = 0; i < k; ++i)
		scanf("%d%d",&p[i].X,&p[i].Y);
	optd = n;
	xo = yo = 0;
	for(int i = 0; i <= n; ++i)
		for(int j = 0; j <= n; ++j)
		{
			int d = 0;
			for(int l = 0; l < k; ++l)
				d = max(d, min(abs(p[l].X - i), abs(p[l].Y - j)));
			if(d < optd)
			{
				optd = d;
				xo = i;
				yo = j;
			}
		}
	printf("%d %d %d\n",optd,xo,yo);
	return 0;
}